<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 31/03/2015
 * Time: 16:01
 */

namespace Service;


use Util\InstanceProvider;
use Zeedhi\DevOps\Util\Utilities;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\Events\PreDispatch\Listener;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\Log\Exception;
use Zeedhi\Framework\Security\OAuth\OAuthImpl;
use Zeedhi\Framework\Session\Session;

class RequestListenerOAuth extends Listener {

    public function __construct(){
        \Util\InstanceProvider::getLog()->setLog('instanciando RequestListenerOAuth',false,2);
    }

    public function preDispatch(Request $request)
    {
        try {
            $this->loginOauth($request);
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage());
        }
    }

    protected function loginOauth(Request $request)
    {
        $environment = InstanceProvider::getEnvironment();
        if(!$environment->getCurrentCdoperador()
            && false === strpos($request->getRoutePath(),'/lib_')
            && false === strpos($request->getRoutePath(),'/acl_zhu_')
        ) {
            $userIdPm = $environment->getCurrentUserIdPm();
            $organizationIdPm = $environment->getCurrentOrganizationIdPm();
            InstanceProvider::getService()->getResource()->setSession($organizationIdPm, $userIdPm);
        } else if(!$environment->getCurrentUserId()) {
            InstanceProvider::getService()->getResource()->setSessionByCdOperador($environment->getCurrentCdoperador());
        }
    }
}